#include "elapsedMillis.h"

typedef union
{
  float number;
  uint8_t bytes[4];
} floatUnion;

volatile int pulse_counter = -1;                       // inizializza contatore fronti
int flagID = 0;                                        // flag per ablitare ricezione ID
int flagPrezzo = 0;                                    // flag per abilitare ricezione Prezzo
byte ID;                                               // ID ricevuto
byte ID_Device = 3;                                    // ID del device
floatUnion prezzo;                                     // Prezzo
int a = 0;
elapsedMillis timeElapsed;                             // Contatore per selezionare il periodo del bit
int vect[8];                                           // Vettore bit ID
int vectPrezzo[32];                                    // Vettore bit Prezzo
int i = 7;
int j = 31;
int fine = 0;                                          // Flag per indicare fine trasmissione
int k;

void setup()
{
  
  pinMode(24,INPUT);                                       // imposta pin 24 come input
  Serial.begin(9600);                                      // prepara la porta seriale
  while (!Serial) {
  }; 
  delay(50); 
                                                                 
  attachInterrupt(digitalPinToInterrupt(24), interrupt_handler, FALLING);              // avvia rutine di interrupt per individuare i fronti di discesa
}

void loop() {
 if(fine == 0)
 { 
  if(pulse_counter == 168)                      // Se è arrivato l'Header
  {
    Serial.println("Header ok");
    noInterrupts();
    pulse_counter = 0;                          // Reset contatore fronti
    interrupts();
    flagID = 1;                                 // Abilita ricezione ID
    delay(13);
  }
  else if(flagID == 1)                          // Se ricezione abilitata
  {
    noInterrupts();
    a = pulse_counter;                         // Salva valore contatore
    interrupts();
    timeElapsed = 0;                           // Azzera contatore durata periodo
    while(timeElapsed < 8)                     // Per tutto il periodo del bit
    {
      vect[i] = a;                             // Salva valore counter nel vettore dell'ID
    }
    if(i == 0)                                 // Se hai ricevuto tutto l'ID 
    {   
      noInterrupts();
      pulse_counter = 0;                       // Reset contatore fronti
      interrupts();
      flagPrezzo = 1;                          // Abilita ricezione prezzo
      flagID = 0;                              // Disabilita ricezione ID
      delay(5);                                // Aspetta 5 ms
    }
    else
    {
      i--;                                    // Passa al bit successivo
    }
  }
  else if(flagPrezzo == 1)                    // Se ricezione abilitata
  {
    noInterrupts();
    a = pulse_counter;                        // Salva valore contatore
    interrupts();
    timeElapsed = 0;                          // Azzera contatore durata periodo
    while(timeElapsed < 8)                    // Per tutto il periodo del bit
    {
      vectPrezzo[j] = a;                      // Salva valore counter nel vettore del Prezzo
    }
    if(j == 0)                                // Se hai ricevuto tutto il Prezzo
    {
      noInterrupts();
      pulse_counter = 0;                      // Reset contatore fronti
      interrupts();
      flagPrezzo = 0;                         // Disabilita ricezione Prezzo
      delay(5);
    }
    else
    {
      j--;                                    // Passa al bit successivo
    }
  } 
  else if(j == 0)                             // verifica valori dei bit nei 2 vettori per debug
  {
    Serial.println("ID pulse counter: ");
    for(i = 7; i >= 0; i--)
    {
      Serial.println(vect[i]);
    }
    Serial.println("Prezzo pulse counter: ");
    for(i = 31; i >= 0; i--)
    {
      Serial.println(vectPrezzo[i]);
    }
    j = 31;   
    fine = 1;                                 // fine comunicazione nuovo prezzo
  }
 }
 else                                         //una volta ricevuto tutto il prezzo
 {
  for(i = 7; i >= 0; i--)                     //decodifica ID
  {
    if(vect[i]%2 != 0)  
    {
      bitWrite(ID, i, 1);                     //bit = 1
    } 
    else  
    {
       bitWrite(ID, i, 0);                    //bit = 0
    }  
  }
  if(ID == ID_Device)                         // se ID ricevuto == a ID del divice
  {
    k = 31;
    for(i = 3; i >= 0; i--)                   // decodifica Prezzo
    {
      for(j = 7; j >= 0; j--)
      {
        if(vectPrezzo[k]%2 != 0) 
        {
          bitWrite(prezzo.bytes[i], j, 1);    // bit = 1
        }
        else 
        {
           bitWrite(prezzo.bytes[i], j, 0);   // bit = 0
        }
        k--;                                  // bit successivo
       }    
      }
      
      Serial.print("L'ID è: ");
      Serial.println(ID);

      Serial.print("Il prezzo è: ");
      Serial.println(prezzo.number);
    }
    else                                    // se ID ricevuto != da ID device
    {
      Serial.println("ID non valido");

      Serial.print("L'ID ricevuto è: ");
      Serial.println(ID);

      k = 31;
      for(i = 3; i >= 0; i--)               // verifica valori ricevuti di ID e Prezzo per debug
      {
        for(j = 7; j >= 0; j--)
        { 
          if(vectPrezzo[k]%2 != 0)
          {
            bitWrite(prezzo.bytes[i], j, 1);
          }
          else
          {
             bitWrite(prezzo.bytes[i], j, 0);
          }
          k--;
        }    
      }

      Serial.print("Il prezzo ricevuto è: ");
      Serial.println(prezzo.number);
    }
    
//    fine = 0;
//    noInterrupts();
//    pulse_counter = 0;
//    interrupts();
//    i = 7; 

     rstc_start_software_reset(RSTC);           //reset parametri per nuovo prezzo
  }
}

void interrupt_handler()
{
  pulse_counter++;
}
